#include "D3DXAnimation.h"
#include <FK/D3DXData.h>

using namespace std;

int fk_D3DXAnimation::GetBoneNum(void)
{
	return (int)frameData.size();
}

string fk_D3DXAnimation::GetBoneName(int argID)
{
	if(argID < 0 || argID >= (int)frameData.size()) return string("");

	return frameData.at(argID)->GetName();
}

fk_Matrix * fk_D3DXAnimation::GetBoneMatrix(int argID)
{
	if(argID < 0 || argID >= GetBoneNum()) return NULL;

	return frameData.at(argID)->GetTotalMatrix();
}

fk_Matrix * fk_D3DXAnimation::GetBoneMatrix(const string argBoneName)
{
	fk_Matrix	*retMatrix = NULL;

	for(unsigned int i = 0; i < frameData.size(); i++) {
		if(frameData.at(i)->GetName() == argBoneName) {
			retMatrix = GetBoneMatrix(i);
			break;
		}
	}

	return retMatrix;
}
