#include "FK/D3DXAnimation.h"
#include <FK/FK.h>
#include "TrackBall.h"
#include <Fl/Fl_File_Chooser.h>


int main(int argc, char *argv[])
{
	Fl_Window		mainWin(800, 600, "TEST");
	fk_Window		viewWin(0, 0, 800, 600);

	fk_Light		light;
	fk_Sphere		sph;
	fk_Line			line;
	fk_Model		lightModel, lineModel, cameraModel;
	fk_Scene		scene;

	fk_Line			grid;
	fk_Model		gridModel;
	fk_Line			axis[3];
	fk_Model		axisModel[3];

	fk_TrackBall	tb(&viewWin, &cameraModel);

	fk_BVHMotion	bvh;
	fk_Model		baseModel;
	int				frm = 0;
	double			sc = 1.0;

	fk_IFSTexture		chara;
	fk_Model			charaModel;
	double				animTime = 0.0;

	mainWin.end();
	fk_InitMaterial();
	// fk_SetErrorMode(FK_ERR_BROWSER_INTERACTIVE);

	// ʃObh
	for(int i = 0; i <= 50; i++) {
		grid.pushLine(fk_Vector(double(i-25)*10.0, 0.0 , 250.0), fk_Vector(double(i-25)*10.0, 0.0 , -250.0));
		grid.pushLine(fk_Vector(-250.0, 0.0 , double(25-i)*10.0), fk_Vector(250.0, 0.0 , double(25-i)*10.0));
	}
	gridModel.setShape(&grid);
	gridModel.setWidth(0.1);
	gridModel.setLineColor(0.1f, 0.1f, 0.1f);

	// 
	axis[0].pushLine(fk_Vector(0.0, 0.0, 0.0), fk_Vector(250.0, 0.0, 0.0));
	axis[1].pushLine(fk_Vector(0.0, 0.0, 0.0), fk_Vector(0.0, 250.0, 0.0));
	axis[2].pushLine(fk_Vector(0.0, 0.0, 0.0), fk_Vector(0.0, 0.0, 250.0));
	axisModel[0].setLineColor(1.0, 0.0, 0.0);
	axisModel[1].setLineColor(0.0, 1.0, 0.0);
	axisModel[2].setLineColor(0.0, 0.0, 1.0);

	// ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.glFocus(0.0, -1.0, -1.0);

	// Jݒ
	cameraModel.glMoveTo(0.0, 0.0, 100.0);
	cameraModel.glFocus(0.0, 0.0, 0.0);
	cameraModel.glUpvec(0.0, 1.0, 0.0);

	tb.setLookTo(fk_Vector(0.0, 0.0, 0.0));

	// V[Gg[
	scene.entryModel(&lightModel);
	scene.entryModel(&gridModel);
	for(int i = 0; i < 3; i++) {
		axisModel[i].setShape(&axis[i]);
		axisModel[i].setWidth(3.0);
		scene.entryModel(&axisModel[i]);
	}
	scene.entryCamera(&cameraModel);

	scene.setBGColor(0.5f, 0.5f, 0.5f);
	scene.setBlendStatus(true);
	viewWin.setScene(&scene);

	mainWin.show();
	viewWin.show();

	if(!chara.readPNG("mireiyu_orient/texture.png")) fl_alert("readPNG() failed.");
	if(!chara.readD3DXFile("mireiyu_orient/mireiyu_orient.x", "mireiyu_oShape")) fl_alert("readD3DXFile() failed.");

	charaModel.setShape(&chara);
	charaModel.setMaterial(White);
	charaModel.setSmoothMode(true);
	//charaModel.setParent(&baseModel);
	scene.entryModel(&charaModel);

	/*
	if(!bvh.readBVHFile("x/test_mireiyu02_Take_001.bvh")) fl_alert("failed.");
	chara.setBVHMotion(&bvh);

	for(int i = 0; i < bvh.getNodeNum(); i++) {
		bvh.getNodeModel(i)->setShape(&sph);
		bvh.getNodeModel(i)->setMaterial(Red);
		bvh.getNodeModel(i)->setSmoothMode(true);
		// scene.entryModel(bvh.getNodeModel(i));

		if(bvh.getNodeModel(i)->getParent() != NULL) {
			line.pushLine(bvh.getNodeModel(i)->getInhPosition(), bvh.getNodeModel(i)->getParent()->getInhPosition());
		} else {
			bvh.getNodeModel(i)->setParent(&baseModel);
		}
	}
	lineModel.setShape(&line);
	lineModel.setLineColor(0.0f, 1.0f, 1.0f);
	lineModel.setWidth(5.0);
	scene.entryModel(&lineModel);
	*/

	DWORD regTime = timeGetTime();

	// Aj[Vf[^̃|C^擾
	fk_D3DXAnimation			*anim = chara.getIFS()->getAnimation();
	fk_Vector					pos;
	fk_Point					point;
	fk_Model					pointModel;

	pos.init();
	point.allClear();
	pointModel.setShape(&point);
	pointModel.setPointColor(0.0, 1.0, 0.0);
	pointModel.setSize(5.0);
	scene.entryModel(&pointModel);

	// {[擾AO\
	for(int i = 0; i < anim->GetBoneNum(); i++) {
		cout << anim->GetBoneName(i) << endl;
	}

	while(true) {
		if(mainWin.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}
		if(viewWin.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(viewWin.winOpenStatus() == false) continue;

		tb.update();
		cameraModel.loTranslate(0.0, 0.0, Fl::e_dy*5.0);
		Fl::e_dy = 0;

		/*
		if(viewWin.getSpecialKeyStatus(FK_RIGHT, false)) {
			frm++;
			if(frm >= bvh.getFrameLength()) frm = bvh.getFrameLength()-1;
			bvh.setFrameCount(frm);
		}
		if(viewWin.getSpecialKeyStatus(FK_LEFT, false)) {
			frm--;
			if(frm < 0) frm = 0;
			bvh.setFrameCount(frm);
		}
		if(viewWin.getSpecialKeyStatus(FK_PAGE_UP)) {
			sc += 0.1;
			if(sc > 10.0) sc = 10.0;
			baseModel.setScale(sc);
		}
		if(viewWin.getSpecialKeyStatus(FK_PAGE_DOWN)) {
			sc -= 0.1;
			if(sc < 0.1) sc = 0.1;
			baseModel.setScale(sc);
		}

		line.allClear();
		for(int i = 0; i < bvh.getNodeNum(); i++) {
			if(bvh.getNodeModel(i)->getParent() != &baseModel) {
				line.pushLine(bvh.getNodeModel(i)->getInhPosition(), bvh.getNodeModel(i)->getParent()->getInhPosition());
			}
		}
		*/

		if(viewWin.getSpecialKeyStatus(FK_DOWN, false)) {
			animTime += 166;
		}
		if(viewWin.getSpecialKeyStatus(FK_UP, false)) {
			animTime -= 166;
			if(animTime < 0.0) animTime = 0.0;
		}
		chara.setAnimationTime(animTime);

		point.allClear();
		// {[݂̌̏Ԃ͍sŎ擾邱Ƃł
		// (0.0, 0.0, 0.0)̃xNgɍsZ邱ƂŁA
		// {[̊_O[oWn̂ǂɈʒu邩߂邱Ƃł
		// (0.0, 0.0, 0.0)ȊO̍Wl΁A_炻ꂾꂽʒu
		// O[oWn̂ǂɈʒu邩߂邱Ƃł
		for(int i = 0; i < anim->GetBoneNum(); i++) {
			point.pushVertex(charaModel.getInhMatrix() * *(anim->GetBoneMatrix(i)) * pos);
			// IDł邵A{[ňƂł
			// ͍̂s̃|C^Ȃ̂ŁA*tĎ̂oAfk_VectorZ
			// s*xNg̏Ԃ͎邱

			// IFSTextureZbgĂ郂fړE]Ăꍇ
			// fk_Model̍sZKv
			// f̍sgetMatrix()Ŏ̂ŁA
			// model.getMatrix() * *(anime->GetBoneMatrix(id)) * boneLocalPos
			// Ȋ
		}

		while((timeGetTime() - regTime) < 16) {
			Sleep(1);
		}
		regTime = timeGetTime();

	}

	return 0;
}
